<?
/* $Id: CheckUserFunctions.inc.php,v 1.4 2005/12/26 13:57:12 volodya Exp $ */

@include("../vars.inc.php");

require ($ADMIN_FOLDER.'consts.inc.php');
require ($ADMIN_FOLDER.'auth.inc.php');
require ($ADMIN_FOLDER.'subdivision.inc.php');
require ($ADMIN_FOLDER.'catalog.inc.php');
require ($ADMIN_FOLDER.'class.inc.php');
require ($ADMIN_FOLDER.'message.inc.php');
require ($ADMIN_FOLDER.'user.inc.php');
require ($ADMIN_FOLDER.'mail.inc.php');
require ($ADMIN_FOLDER.'template.inc.php');
require ($ADMIN_FOLDER.'field.inc.php');
require ($ADMIN_FOLDER.'sub_class.inc.php');
require ($ADMIN_FOLDER.'system_table.inc.php');
require ($ADMIN_FOLDER.'module.inc.php');

#   
function Language_Show() {
   global $ADMIN_FOLDER;

   
   if ($handle = opendir($ADMIN_FOLDER."lang")) {

   $lang=array();

   while (false !== ($file = readdir($handle))) {
      if (strlen($file)>4) {
       $name=explode(".", $file);
       $lang[$file]=$name[0];
      }
   }

   closedir($handle);
 
  return($lang);

 } else {
  return(false);
 }

}


function NetCat_language_detect() {
   global $_SERVER, $ADMIN_LANGUAGE;

	$langtable = array(
	'af' => 'Afrikaans',
	'sq' => 'Albanian',
	'ar' => 'Arabic',
	'hy' => 'Armenian',
	'as' => 'Assamese',
	'az' => 'Azeri',
	'eu' => 'Basque',
	'be' => 'Belarusian',
	'bn' => 'Bengali',
	'bg' => 'Bulgarian',
	'ca' => 'Catalan',
	'zh' => 'Chinese',
	'hr' => 'Croatian',
	'cs' => 'Chech',
	'da' => 'Danish',
	'div' => 'Divehi',
	'nl' => 'Dutch',
	'en' => 'English',
	'et' => 'Estonian',
	'fo' => 'Faeroese',
	'fa' => 'Farsi',
	'fi' => 'Finnish',
	'fr' => 'French',
	'mk' => 'FYRO Macedonian',
	'gd' => 'Gaelic',
	'ka' => 'Georgian',
	'de' => 'German',
	'el' => 'Greek',
	'gu' => 'Gujarati',
	'he' => 'Hebrew',
	'hi' => 'Hindi',
	'hu' => 'Hungarian',
	'is' => 'Icelandic',
	'id' => 'Indonesian',
	'it' => 'Italian',
	'ja' => 'Japanese',
	'kn' => 'Kannada',
	'kk' => 'Kazakh',
	'kok' => 'Konkani',
	'ko' => 'Korean',
	'kz' => 'Kyrgyz',
	'lv' => 'Latvian',
	'lt' => 'Lithuanian',
	'ms' => 'Malay',
	'ml' => 'Malayalam',
	'mt' => 'Maltese',
	'mr' => 'Marathi',
	'mn' => 'Mongolian',
	'ne' => 'Nepali',
	'no' => 'Norwegian',
	'or' => 'Oriya',
	'pl' => 'Polish',
	'pt' => 'Portuguese',
	'pa' => 'Punjabi',
	'rm' => 'Rhaeto-Romanic',
	'ro' => 'Romanian',
	'ru' => 'Russian',
	'sa' => 'Sanskrit',
	'sr' => 'Serbian',
	'sk' => 'Slovak',
	'ls' => 'Slovenian',
	'sb' => 'Sorbian',
	'es' => 'Spanish',
	'sx' => 'Sutu',
	'sw' => 'Swahili',
	'sv' => 'Swedish',
	'syr' => 'Syriac',
	'ta' => 'Tamil',
	'tt' => 'Tatar',
	'te' => 'Telugu',
	'th' => 'Thai',
	'ts' => 'Tsonga',
	'tn' => 'Tswana',
	'tr' => 'Turkish',
	'uk' => 'Ukrainian',
	'ur' => 'Urdu',
	'uz' => 'Uzbek',
	'vi' => 'Vietnamese',
	'xh' => 'Xhosa',
	'yi' => 'Yiddish',
	'zu' => 'Zulu');
	
	$userlang = strtolower($_SERVER["HTTP_ACCEPT_LANGUAGE"]);
	$userlang = explode(",", $userlang);

	$langs=array();

	foreach($userlang as $key=>$val) {
	   $i=substr($val, 0, 2);
	   $langs[$i]=$langtable[$i];
	}

	$nclang=Language_Show();

	foreach($langs as $key=>$val) {
		if (in_array($val, $nclang, true)) {
       			return($ADMIN_LANGUAGE);
       	 	}
	}
	return(false);
}


function  Unauthorize () {
        global $HTTP_HOST, $EDIT_DOMAIN, $AUTHORIZATION_TYPE;
        global $PHP_AUTH_USER, $PHP_AUTH_PW, $_SERVER, $PHP_AUTH_LANG;
	global $PHPSESSID;

        if ($AUTHORIZATION_TYPE=='cookie') {
                $EditDomainHost = substr($EDIT_DOMAIN,0,strlen($EDIT_DOMAIN)-strlen(strchr($EDIT_DOMAIN,"/")));

                setcookie ("PHP_AUTH_USER", NULL, NULL, "/");
                setcookie ("PHP_AUTH_PW", NULL, NULL, "/");
                setcookie ("PHP_AUTH_LANG", NULL, NULL, "/");

        } elseif ($AUTHORIZATION_TYPE=='http') {
      unset($_SERVER['PHP_AUTH_USER']);
      unset($_SERVER['PHP_AUTH_PW']);
	  unset($_SERVER['HTTP_AUTHORIZATION']);
        } elseif ($AUTHORIZATION_TYPE=='session') {
	$sname = session_name();
	if ($$sname != "") {
	$$sname = $_POST['$sname'];
	$$sname = $_GET['$sname'];
	}
	
	session_start();
        unset($_SESSION['User']);
        session_destroy();
        header("Location: /netcat/admin/");
        }
}

function LoginFormHeader () {
        global $VERSION_ID, $SYSTEM_NAME;
?>
<html>
<head><style>body{margin:0px;background-color:white}td,th,.plain{font-family:verdana;font-size:x-small}</style>
<title>NetCat <?echo $VERSION_ID?> <?echo $SYSTEM_NAME?></title>
</head>
<body marginheight=0 marginwidth=0>
<table border=0 cellpadding=4 cellspacing=0 width=100% height=50%>
<tr><td align=center bgcolor=006699><font color=white><b><?=CONTROL_AUTH_HTML_CMS?> NetCat <?echo $VERSION_ID?> <?echo $SYSTEM_NAME?></td></tr>
<tr><td height=100% align=center>
<?
}

function LoginFormFooter () {
?>
</td></tr>
<tr><td align=center bgcolor=006699><font color=white>&copy; 1999-<?echo date("Y")?> <a href=http://www.aist.ru><font color=white><?=ENDHTML_AIST?></a></td></tr>
</table>
</body>
</html>
<?
}

function LoginForm ()
{
 global $REQUEST_URI, $AUTH_USER, $ADMIN_LANGUAGE;
 global $posting, $USER_LANG, $ADMIN_AUTHTYPE, $AUTHORIZATION_TYPE, $_COOKIE;

?>

<table border=0 cellpadding=4 cellspacing=0>
<form action=<?=$REQUEST_URI?> method=post>
<tr><td><?=CONTROL_AUTH_HTML_LOGIN?>:</td><td><input type=text name=AUTH_USER size=32 maxlength=32 value='<?echo $AUTH_USER?>'></td></tr>
<tr><td><?=CONTROL_AUTH_HTML_PASSWORD?>:</td><td><input type=password name=AUTH_PW size=32 maxlength=32></td></tr>
<tr><td><?=CONTROL_AUTH_HTML_LANG?>:</td><td><select name=NEW_AUTH_LANG>
<?
  $lang=Language_Show();
  
  if ($_COOKIE['PHP_AUTH_LANG']) {
  	$sellang=$_COOKIE['PHP_AUTH_LANG'];
  } else {
  	$sellang=$ADMIN_LANGUAGE;
  }
  
  foreach($lang as $key=>$val) {
    if ($val==$sellang) {
      echo("<option name='".$key."' selected='selected'>".$val."</option>\n");
    } else {
      echo("<option name='".$key."'>".$val."</option>\n");
    }
  }
?></select></td></tr>
<?php
 if ($ADMIN_AUTHTYPE=="manual" and $AUTHORIZATION_TYPE=="cookie") {
   echo("<tr><td></td><td><label><input type=\"checkbox\" name=\"loginsave\" />&nbsp;".CONTROL_AUTH_HTML_SAVELOGIN."</label></td></tr>\n");
 }
?>
<tr><td></td><td><input type=submit name=submit value="<?=CONTROL_AUTH_HTML_AUTH?>"><?if ($posting && $REQUEST_URI!=$REQUESTED_FROM) {?><br><a href=<?echo $REQUESTED_FROM?>><?=CONTROL_AUTH_HTML_BACK?></a><?}?></td></tr>
<input type=hidden name=AuthPhase value=1>
</form>
</table>
<?

}


function Refuse ()
{
 global $LinkID, $ADMIN_FOLDER;
 global $AUTH_TYPE, $AUTH_LANG, $PHP_AUTH_LANG, $_SESSION, $ADMIN_LANGUAGE;
 global $NOT_AUTHORIZE_MESSAGE;
 global $admin_mode;
 
 if ($AUTH_LANG) {
	require_once($ADMIN_FOLDER."lang/".$AUTH_LANG.".php");
} elseif($PHP_AUTH_LANG) {
   require_once($ADMIN_FOLDER."lang/".$PHP_AUTH_LANG.".php");
} elseif($_SESSION['User']['PHP_AUTH_LANG']) {
   require_once($ADMIN_FOLDER."lang/".$_SESSION['User']['PHP_AUTH_LANG'].".php");
} else {
  if (!$PHP_AUTH_LANG) $PHP_AUTH_LANG=NetCat_language_detect();
  if ($PHP_AUTH_LANG) {
    require_once($ADMIN_FOLDER."lang/".$PHP_AUTH_LANG.".php");
  } else {
    require_once($ADMIN_FOLDER."lang/".$ADMIN_LANGUAGE.".php");
  }
}


 switch ($AUTH_TYPE) {
   case 'cookie':
        if (!$admin_mode) {
                UserLoginForm ();
        } else {
                LoginFormHeader();
                LoginForm ();
                LoginFormFooter();
        }
        break;
   end;
   case 'session':
      if (!$admin_mode) {
          UserLoginForm ();
      } else {
          LoginFormHeader();
          LoginForm ();
          LoginFormFooter();
      }
      break;
    end;
                                                                                                 

   default :
   #    'http'
        Header ("WWW-authenticate:  basic  realm=Enter your login and password");
        Header ("HTTP/1.0  401  Unauthorized");
        LoginFormHeader();
        print CONTROL_AUTH_MSG_MUSTAUTH;
        LoginFormFooter();
   end;
 }

 exit;

}

function Authorize ($IsInAdmin=0)
{
  $sname = session_name();   
  global $PHP_AUTH_USER, $PHP_AUTH_PW, $PHP_AUTH_LANG;
  global $AUTH_USER_ID, $AUTH_USER_GROUP;
  global $AUTH_USER, $AUTH_PW, $AUTH_LANG;
  global $AUTHORIZATION_TYPE, $_POST, $_GET;
  global $EDIT_DOMAIN, $AUTH_TYPE, $HTTP_HOST;
  global $LinkID;
  global $perm, $AuthPhase, $admin_mode;
  global $AUTHORIZE_BY;
  global $$sname, $ADMIN_AUTHTIME, $ADMIN_AUTHTYPE;

  $AUTH_TYPE = $AUTHORIZATION_TYPE;
  
  if ($AUTH_TYPE=='session') {

if ($$sname !="") {

if (!ereg("^[a-f0-9]{32}$",$$sname)) {
header ("Location: /netcat/admin/");
}

$_GET[session_name()] = $$sname;
$_POST[session_name()] = $$sname;
} else {
srand((double)microtime()*1000000);
$randval = rand();
$session_id=md5(uniqid($randval));
session_id($session_id);
}
session_start();
if ($_SESSION['User']['IsLogin']=="1") {
if ($_SESSION['User']['IP'] != getenv("REMOTE_ADDR")) {
header ("Location: /");
}
if ((time()-$_SESSION['User']['datetime']) > ini_get('session.gc_maxlifetime')) {
unset($_SESSION['User']);
}
}

$_SESSION['User']['datetime'] = time();

  $PHP_AUTH_USER = $_SESSION['User']['PHP_AUTH_USER'];
  $PHP_AUTH_PW = $_SESSION['User']['PHP_AUTH_PW'];
  $PHP_AUTH_LANG = $_SESSION['User']['PHP_AUTH_LANG'];
  }

  if ($AUTH_TYPE != 'http') {
     if ($AuthPhase) {
        $PHP_AUTH_USER = $AUTH_USER;
        $PHP_AUTH_PW = $AUTH_PW;
        $PHP_AUTH_LANG = $AUTH_LANG;
     }
  }

  if (!isset($PHP_AUTH_USER)) {
        if ($admin_mode || $AUTHORIZATION_TYPE=="http") Refuse ();
        else return false;
  }

  $Result = mysql_query ("SELECT User_ID,Password,PermissionGroup_ID,Language FROM User WHERE ".$AUTHORIZE_BY."='".$PHP_AUTH_USER."' AND Password=".((!$AuthPhase && $AUTH_TYPE=='cookie')?"'".$PHP_AUTH_PW."'":"PASSWORD('".$PHP_AUTH_PW."')")." AND Checked=1", $LinkID);
  if (!mysql_num_rows ($Result)) {
        if ($admin_mode || $AUTHORIZATION_TYPE=="http") Refuse ();
        else return false;
  }

  list ($UserID, $Password, $UserGroup,$Language) = mysql_fetch_row ($Result);
  mysql_free_result($Result);

  if ($Language) {
  	$AUTH_LANG=$Language;
  	$PHP_AUTH_LANG=$Language;
  }
  
  if ($AUTH_TYPE=='cookie') {
        if ($AuthPhase) {
        	$EditDomainHost = substr($EDIT_DOMAIN,0,strlen($EDIT_DOMAIN)-strlen(strchr($EDIT_DOMAIN,"/")));

        	if ($_POST['loginsave']=="on" or $ADMIN_AUTHTYPE=="always") {

                setcookie ("PHP_AUTH_USER", $PHP_AUTH_USER, time()+24*3600, "/");
                setcookie ("PHP_AUTH_PW", $Password, time()+24*3600, "/");
                setcookie ("PHP_AUTH_LANG", $PHP_AUTH_LANG, time()+24*3600, "/");
                
        	} else {

                setcookie ("PHP_AUTH_USER", $PHP_AUTH_USER, 0, "/");
                setcookie ("PHP_AUTH_PW", $Password, 0, "/");
                setcookie ("PHP_AUTH_LANG", $PHP_AUTH_LANG, 0, "/");

        	}
        }
  } elseif ($AUTH_TYPE=='http') {
        #    'http'
        end;
  } elseif ($AUTH_TYPE=='session') {
	
if ($$sname !="") {

if (!ereg("^[a-f0-9]{32}$",$$sname)) {
header ("Location: /");
}

$_GET[session_name()] = $$sname;
$_POST[session_name()] = $$sname;
} else {
srand((double)microtime()*1000000);
$randval = rand();
$session_id=md5(uniqid($randval));
session_id($session_id);
@ini_set("session.gc_maxlifetime", $ADMIN_AUTHTIME);
}
        session_start();
        $_SESSION['User']['ID'] = $UserID;
        $_SESSION['User']['PHP_AUTH_USER'] = $PHP_AUTH_USER;
        $_SESSION['User']['PHP_AUTH_PW'] = $PHP_AUTH_PW;
        $_SESSION['User']['PHP_AUTH_LANG'] = $PHP_AUTH_LANG;
	$_SESSION['User']['datetime'] = time();
	$_SESSION['User']['IsLogin'] = "1";
	$_SESSION['User']['IP'] = getenv("REMOTE_ADDR");
        end;
  } else {
        if ($admin_mode || $AUTHORIZATION_TYPE=="http") Refuse ();
        else return false;
  }

  $AUTH_USER_ID = $UserID;
  $AUTH_USER_GROUP = $UserGroup;

  $perm = new Permission ($UserID);

  return ($UserID);
}


function CheckUserRights ($SubClassID, $action, $posting)
{
 global $LinkID;
 global $perm;

 #  action
 #   1 - read
 #   2 - add
 #   4 - subscribe
 #   8 - change
 #  16 - moderate

 if ( $perm->isSupervisor() ) return 1;
 if ( $perm->isManager() ) return 1;

 switch ($action) {
   case "read": $mask = 1;   break;
   case "add":  $mask = 2;   break;
   case "change":    $mask = 4;   break;
   case "subscribe": $mask = 8;   break;
   case "moderate":  $mask = 16;   break;
   default:		$mask = 1;   break;
 }

 if ( $perm->isGuest() )  {
    if ($posting == 0)
       return 1; 
    elseif ( $mask == 1 )
       return 1; 
    else
       return 0;
 }


 $SubdivisionID = GetSubdivisionBySubClass ($SubClassID);
 $CatalogueID = GetCatalogueBySubdivision ($SubdivisionID);

 if ( $perm->isCatalogue($CatalogueID, $mask) ) {
    return $perm->isCatalogue ($CatalogueID, $mask);
 }

 while ($SubdivisionID) {
       $val = $perm->isSubdivision ($SubdivisionID, $mask);
       if ($val == 1) return 1;
       $SubdivisionID = GetParentSubID ($SubdivisionID);
 }


 if ( $perm->isSubClass($SubClassID, $mask) ) {
    return $perm->isSubClass ($SubClassID, $mask);
 }


 return 0;
}

?>
